
public class SelfOrgList {
	// <Loesungsvorschlag>
	Node head;

	SelfOrgList() {
		head = null;
	}

	void prepend(int key, String val) {
		Node node = new Node(key, val);
		node.next = head;
		head = node;
	}

	String find(int key) {
		Node cur = head;
		Node prev = null;
		// Search for element with specified key
		while ((cur != null) && (cur.key != key)) {
			prev = cur;
			cur = cur.next;
		}
		if (cur == null) {
			// Not found
			return null;
		}
		else {
			// Found => remove and insert at first position
			if (head != cur) {
				prev.next = cur.next;
				cur.next = head;
				head = cur;
			}
			return cur.val;
		}
	}

	String remove(int key) {
		String val = find(key);
		if (val != null) {
			// Element exists => remove
			head = head.next;
		}
		return val;
	}
	// </Loesungsvorschlag>

	// Normalerweise sollte der Testtreiber in einer eigenen
	// Testklasse stehen
	public static void main(String[] args) {
		SelfOrgList list = new SelfOrgList();
		list.prepend(2, "Test2");
		list.prepend(4, "Test4");
		list.prepend(12, "Test12");
		list.prepend(8, "Test8");
		Out.println("Find 8:" + list.find(8));
		Out.println("Find 8:" + list.find(8));
		Out.println("Find 4:" + list.find(4));
		Out.println("Find 12:" + list.find(12));
		Out.println("Find 2:" + list.find(2));
		Out.println("Find 7:" + list.find(7));

		Out.println("Remove 7:" + list.remove(7));
		Out.println("Remove 2:" + list.remove(2));
		Out.println("Remove 4:" + list.remove(4));
		Out.println("Remove 4:" + list.remove(4));
		Out.println("Remove 12:" + list.remove(12));
		Out.println("Remove 8:" + list.remove(8));
		Out.println("Remove 8:" + list.remove(8));
	}

}